local moduleName = "target"

local L = AceLibrary('AceLocale-2.2'):new('SimpleUnitFrames_Target')

L:RegisterTranslations('enUS', function() return {

	target_desc = "Options for target frame",
	
	hp = "Health Text",
	mp = "Mana Text",
	hp_desc = "Set health text to one of the styles",
	mp_desc = "Set mana text to one of the styles",
	
	
} end)


local Target = SimpleUnitFrames:NewModule(moduleName, "AceEvent-2.0")

Target.core.defaults[moduleName] = {
	hp = "mh3completehp",
	mp = "currmaxmp",
}

Target.consoleOptions = {
	type = 'group',
	name = 'party',
	desc = L['target_desc'],
	args = {	
		hp = {
			type = 'group',
			name = L['hp'],
			desc = L['hp_desc'],
			args = {}
		},
		mp = {
			type = 'group',
			name = L['mp'],
			desc = L['mp_desc'],
			args = {}
		},
	}
}

function Target:OnInitialize()

	self:PopulateOptions(self.consoleOptions, self.db)
	
	TargetDeadText:SetText()
	
	self:RegisterEvent("UNIT_HEALTH", "OnHealthChange" )
	self:RegisterEvent("UNIT_MAXHEALTH", "OnHealthChange" )
	self:RegisterEvent("UNIT_MANA", "OnManaChange" )
	self:RegisterEvent("UNIT_MAXMANA", "OnManaChange")
	self:RegisterEvent("UNIT_ENERGY", "OnManaChange")
	self:RegisterEvent("UNIT_MAXENERGY", "OnManaChange")
	self:RegisterEvent("UNIT_RAGE", "OnManaChange")
	self:RegisterEvent("UNIT_MAXRAGE", "OnManaChange")
	self:RegisterEvent("UNIT_DISPLAYPOWER", "OnManaChange")
	self:RegisterEvent("PLAYER_TARGET_CHANGED")
	
	if UnitExists('target') then
		self:UpdateHealth()
		self:UpdateMana()
	end
	
end


function Target:PLAYER_TARGET_CHANGED()
	if UnitExists('target') then
		self:UpdateHealth()
		self:UpdateMana()
	end
end

function Target:OnHealthChange(arg1)
	if arg1 == 'target' then
		self:UpdateHealth()
	end
end

function Target:OnManaChange(arg1)
	if arg1 == 'target' then
		self:UpdateMana()
	end
end

function Target:UpdateHealth()
	SUF_TargetHealthText:SetText( self:GetValueText('target', self.db.hp) )
end

function Target:UpdateMana()
	SUF_TargetManaText:SetText( self:GetValueText('target', self.db.mp) )
end
